### IP packet handler for IP simulator ###
#
# Public domain software
# (When using Python 2, part of this program must be commented/uncommented)
#
# Coded by Yasusi Kanada
# 2015-5-10

### Packet field access ###

def SIP(packet):
    return packet[24:32].decode('utf-8')			# !! Python 3 !!
    # return packet[24:32]					# !! Python 2 !!

def DIP(packet):
    return packet[32:40].decode('utf-8')			# !! Python 3 !!
    # return packet[32:40]					# !! Python 2 !!

def Payload(packet):
    return packet[40:].decode('utf-8')				# !! Python 3 !!
    # return packet[40:]					# !! Python 2 !!


### Packet handler ###

def hex2decIPv4(hexIP):
    return str(int(hexIP[0:2], 16)) + "." + str(int(hexIP[2:4], 16)) + "." + \
        str(int(hexIP[4:6], 16)) + "." + str(int(hexIP[6:8], 16))

def printPacket(packet, now, message):
    print(message, len(packet) // 2, "bytes  time:", now,
          "\n  Source IP:", hex2decIPv4(SIP(packet)), \
          " Dest. IP:", hex2decIPv4(DIP(packet)),
          "\n  Payload:", Payload(packet))	# !! Python 3 !!
    # print message, len(packet) // 2, "bytes  time:", now,
    #     "\n  Source IP:", SIP(packet), " Dest. IP:", DIP(packet),
    # 	  "\n  Payload:", Payload(packet)	# !! Python 2 !!
