### IP server simulator (UDP w/o select) ###
#
# Public domain software
# (When using Python 2, part of this program must be commented/uncommented)
#
# Coded by Yasusi Kanada
# 2015-5-17

import optparse, socketserver, time, socket
from ip import SIP, DIP, printPacket

payload = None

host = socket.gethostbyname(socket.gethostname())


class EthernetServer(socketserver.BaseRequestHandler):

    ### Packet handler ###

    def handle(self):
        packet = self.request[0]
        socket = self.request[1]
        destIP = DIP(packet)
        sourceIP = SIP(packet)
        localIP = hex(int(opts.lip))[2:]
        if destIP == localIP:
            now = time.time()
            printPacket(packet, now, "Received:")

            sendPacketString = "450000244000400080000000" + \
                               localIP + sourceIP + payload
            sendPacket = bytes(sendPacketString, 'utf-8')  # !! Python 3 !!
            # sendPacket = sendPacketString		   # !! Python 2 !!
            sendBytes = socket.sendto(sendPacket, self.client_address)
            printPacket(sendPacket, now, "Sent:    ")

if __name__ == "__main__":
    # Parse command line
    parser = optparse.OptionParser()
    parser.add_option("--lp", "--lport", "--localPort", dest = "lport", type="int",
                      help = "Local network port id")
    parser.add_option("--rp", "--rport", "--remotePort", dest = "rport", type="int",
                      help = "Remote (next) network port id")
    parser.add_option("--lip", "--localIP", dest = "lip", type = "str",
                      help = "Local (my) IP address")
    parser.set_defaults(lport = 4000, rport = 5000, lip = "00000000")
    opts, args = parser.parse_args()

    # Contents of packet to send (constant)
    payload = "0f0e0d0c0b0a09080706050403020100"

    server = socketserver.UDPServer((host, opts.lport), EthernetServer)
    server.serve_forever()
