### IP terminal simulator (UDP w/o select) ###
#
# Public domain software
# (When using Python 2, part of this program must be commented/uncommented)
#
# Coded by Yasusi Kanada
# 2015-5-17

import optparse, socket, time
from ip import SIP, DIP, Payload, printPacket

BUF_SIZE = 3100		# > 2 * 1500

host = socket.gethostbyname(socket.gethostname())


### Main program ###

def terminal():
    # Parse command line
    parser = optparse.OptionParser()
    parser.add_option("--lp", "--lport", "--localPort", dest = "lport", type="int",
                      help = "Local network port id")
    parser.add_option("--rp", "--rport", "--remotePort", dest = "rport", type="int",
                      help = "Remote (next) network port id")
    parser.add_option("--lip", "--localIP", dest = "lip", type = "str",
                      help = "Local (my) IP address")
    parser.add_option("--rip", "--remoteIP", dest = "rip", type = "str",
                      help = "Remote (receiver) IP address")
    parser.add_option("--receiveOnly", dest = "receiveOnly", action = "store_true")
    parser.set_defaults(lport = 4000, rport = 5000,
                        lip = "00000000", rip = "00000000")
    opts, args = parser.parse_args()

    # Open socket
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.setblocking(0)
    sock.bind((host, opts.lport))
    
    localIP = hex(int(opts.lip))[2:]
    remoteIP = hex(int(opts.rip))[2:]

    # Contents of packet to send (constant)
    sendPacketString = "450000244000400080000000" + localIP + remoteIP + \
                       "000102030405060708090a0b0c0d0e0f"
    sendPacket = bytes(sendPacketString, 'utf-8')		# !! Python 3 !!
    # sendPacket = sendPacketString				# !! Python 2 !!

    # Repeat sending and receiving packets
    interval = 1
    lastTime = time.time();
    while True:
        now = time.time()

        try:
            packet = sock.recv(BUF_SIZE)
        except socket.error:
            pass
        else:
            destIP = DIP(packet)
            if destIP == localIP:
                printPacket(packet, now, "Received:")

        if not opts.receiveOnly:
            if now > lastTime + interval:
                sendBytes = sock.sendto(sendPacket, (host, opts.rport))
                printPacket(sendPacket, now, "Sent:    ")
                lastTime = now
            else:
                time.sleep(0.001001)
        else:
            time.sleep(0.001001)

terminal()
